## pan 0.164

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "Do not build in-source. Please remove CMakeCache.txt and the CMakeFiles/ directory. Then build out-of-source.")
endif()

file(STRINGS "NEWS" news LIMIT_COUNT 1)
string(REGEX MATCH "[0-9.]+" pan_version ${news})
string(REGEX MATCH "\"[a-zA-Z ]+\"" quoted_pan_title ${news})
# remove quotes
string(REGEX REPLACE "\"" "" VERSION_TITLE ${quoted_pan_title})
message(STATUS "Building Pan version ${pan_version} (${VERSION_TITLE})")

# https://cmake.org/cmake/help/latest/command/project.html
project(Pan
  VERSION ${pan_version}
  DESCRIPTION "Pan usenet reader"
  HOMEPAGE_URL "https://gitlab.gnome.org/GNOME/pan"
)

# #cmakedefine completely refuses to recognise CMAKE_PROJECT_VERSION_xxxx or
# PROJECT_VERSION_xxxx
set(VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(VERSION_TWEAK ${PROJECT_VERSION_TWEAK})

set(PAN_DBUS_SERVICE_NAME      "org.gnome.pan")
set(PAN_DBUS_SERVICE_PATH      "/news/pan/NZB")

# Standard CMake modules
include(CTest)

# https://cmake.org/cmake/help/latest/module/CheckIncludeFile.html
include(CheckIncludeFile)
# This will define the default values for installation directories (all platforms even if named GNU)
# https://cmake.org/cmake/help/latest/module/GNUInstallDirs.html
include(GNUInstallDirs)
set(PACKAGE "pan")

set(PACKAGE_BUGREPORT "https://gitlab.gnome.org/GNOME/pan/issues")

# see https://gitlab.gnome.org/GNOME/pan/-/issues/175
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# see https://cmake.org/cmake/help/latest/module/FindThreads.html
find_package(Threads REQUIRED)

# backward compat. There's a lot of ifdef #HAVE_CONFIG_H, #include config.h
# Don't know why...
# https://cmake.org/cmake/help/latest/command/add_compile_definitions.html
add_compile_definitions(HAVE_CONFIG_H)

# Silence deprecation warnings for things deprecated before 2.26,
# and generally set the target behaviour to be like GLib 2.26.
# In principle this should match $GLIB_REQUIRED, but 2.26 is the oldest
# version for which the macros exist (and has been unsupported since
# around 2011 in any case).
add_compile_definitions(GLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_2_26)

# Highest version number from which new features are allowed to be used,
# even within a GLIB_CHECK_VERSION check. GLib will produce compile-time
# warnings when features of a newer GLib version are used.
add_compile_definitions("GLIB_VERSION_MAX_ALLOWED=G_ENCODE_VERSION(2,36)")

include_directories("${CMAKE_SOURCE_DIR}")
# this is where config.h is generated
include_directories(${CMAKE_BINARY_DIR})

# https://cmake.org/cmake/help/latest/command/add_executable.html
add_executable(pan pan/gui/pan.cc pan/gui/gui.cc)
# remove this so pan binary lands in build dir. But this requires
# first to rename pan/ dir to src/
set_target_properties(pan PROPERTIES RUNTIME_OUTPUT_DIRECTORY "pan/gui")
target_compile_options(pan PRIVATE "${CXX_STD}" "-Wreorder" "-Wzero-as-null-pointer-constant")

# Don't embed GIT_REV for a reproducible build or when building from a
# tarball. The former is mostly done in Linux distribution build where
# git rev is not the same as upstream.
if (EXISTS ".git" AND NOT DEFINED ENV{SOURCE_DATE_EPOCH})
  # Get the latest abbreviated commit hash of the working branch
  # see https://jonathanhamberg.com/post/cmake-embedding-git-hash/
  # drawback: commited changed are not taken into account until "cmake ." is run
  execute_process(
    COMMAND git log -1 --format=%h
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
    OUTPUT_VARIABLE GIT_REV
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  message(STATUS "Git rev: ${GIT_REV}")
endif ()

CHECK_INCLUDE_FILE(errno.h HAVE_ERRNO_H)
CHECK_INCLUDE_FILE(fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE(unistd.h HAVE_UNISTD_H)

# https://cmake.org/cmake/help/latest/module/CheckSymbolExists.html
include(CheckSymbolExists)
check_symbol_exists(close "unistd.h" HAVE_CLOSE)
check_symbol_exists(localtime_r "time.h" HAVE_LOCALTIME_R)

set(GETTEXT_PACKAGE pan)

find_package(PkgConfig REQUIRED)

function(my_target_system_lib target scope libname)
  # https://cmake.org/cmake/help/latest/command/include_directories.html
  target_include_directories(${target} ${scope} ${${libname}_INCLUDE_DIRS})
  target_compile_options(${target} ${scope} ${${libname}_CFLAGS})
  target_link_directories(${target} ${scope} ${${libname}_LIBRARY_DIRS})
  target_link_libraries(${target} ${scope} ${${libname}_LIBRARIES})
endfunction()

# see https://github.com/shlomif/gtk3-cmake-examples/blob/master/CMakeLists.txt
# Use the package PkgConfig to detect GTK+ headers/library files
pkg_check_modules(GTK3 REQUIRED IMPORTED_TARGET  gtk+-3.0>=3.16.0)

# https://cmake.org/cmake/help/latest/command/find_package.html
# https://cmake.org/cmake/help/latest/module/FindIconv.html
find_package(Iconv)
set(HAVE_ICONV ${Iconv_FOUND})

# https://cmake.org/cmake/help/latest/module/FindZLIB.html
find_package(ZLIB 1.2.0 REQUIRED)
set(HAVE_ZLIB ${ZLIB_FOUND})

# D-Bus support
# https://cmake.org/cmake/help/latest/command/option.html
option(WANT_DBUS "enable D-Bus support (default: no)")
if(WANT_DBUS)
  set(HAVE_DBUS TRUE)
endif()

# https://cmake.org/cmake/help/latest/module/FindPkgConfig.html#command:pkg_check_modules
pkg_check_modules(GMIME REQUIRED IMPORTED_TARGET gmime-3.0)

pkg_check_modules(GLIB REQUIRED IMPORTED_TARGET glib-2.0>=2.26.0)

# Check for GMime cryptography support
option(WANT_GMIME_CRYPTO "enable GMime cryptography support (default: no)")
if(WANT_GMIME_CRYPTO)
  set(HAVE_GMIME_CRYPTO TRUE)
endif()

# GtkSpell support
option(WANT_GSPELL "enable Gspell support (default: on)" ON)
if(WANT_GSPELL)
  pkg_check_modules(GSPELL REQUIRED IMPORTED_TARGET gspell-1)
  set(HAVE_GSPELL true)
endif()

option(WANT_WEBKIT "enable WebKitGTK support (experimental, default: off)")
if(WANT_WEBKIT)
  pkg_check_modules(WEBKITGTK REQUIRED IMPORTED_TARGET webkitgtk-3.0>=1.8.1)
  set(HAVE_WEBKIT true)
endif()

option(WANT_GNUTLS "enable GnuTLS support (default: on)" ON)
if(WANT_GNUTLS)
  pkg_check_modules(GNUTLS REQUIRED IMPORTED_TARGET gnutls>=3.3.6)
  set(HAVE_GNUTLS true)
endif()

option(WANT_NOTIFY "enable libnotify support (default: off)")
if(WANT_NOTIFY)
  pkg_check_modules(LIBNOTIFY REQUIRED IMPORTED_TARGET libnotify>=0.4.1)
  set(HAVE_LIBNOTIFY true)
endif()

option(WANT_GKR "enable GNOME Keyring or libsecret support (default: off)")
if(WANT_GKR)
  pkg_check_modules(LIBSECRET REQUIRED IMPORTED_TARGET libsecret-1>=0.16)
  pkg_check_modules(GCR3 REQUIRED IMPORTED_TARGET gcr-3>=3.20)
  set(HAVE_GKR TRUE)
endif()

option(ENABLE_MANUAL "built in user manual (default: off)")
if (ENABLE_MANUAL)
  set(HAVE_MANUAL 1)
endif()

# Check to see if strftime supports the use of %l and %k
# https://cmake.org/cmake/help/latest/command/try_run.html
# this requires cmake 3.25
try_run(HAVE_LKSTRFTIME COMPILED_LKSTRFTIME_TEST
  SOURCE_FROM_CONTENT test-strftime.c "
#include <string.h>
#include <stdlib.h>
#include <time.h>
int main(int argc, char **argv) {
  char buf[10];
  time_t rawtime = time(0);
  struct tm *timeinfo = localtime (&rawtime);
  strftime(buf, 10, \"%l %k\", timeinfo);
  exit (strstr(buf, \"l\") || strstr(buf, \"k\") || !strcmp(buf,\" \") || !strlen(buf));
}
")

if(NOT COMPILED_LKSTRFTIME_TEST)
  message(WARNING "failed to compile test-strftime.c")
endif()

# Don't embed uname -sr in PLATFORM_INFO for a reproducible build.
if (NOT DEFINED ENV{SOURCE_DATE_EPOCH})
  set(PLATFORM_INFO ${CMAKE_HOST_SYSTEM})
  message(STATUS "platform: ${PLATFORM_INFO}")
endif ()

# https://cmake.org/cmake/help/latest/manual/cmake-variables.7.html
if(APPLE)
  set(G_OS_DARWIN TRUE)
  # TODO: set LOCALEDIR
elseif(WIN32)
  # https://cmake.org/cmake/help/latest/command/target_compile_options.html
  #add_compile_options(mms-bitfields)
  add_compile_definitions(WIN32_LEAN_AND_MEAN)
  target_link_libraries(pan shell32 ws2_32 pthread)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mwindows")
  # TODO: set LOCALEDIR
else()
  set(LOCALEDIR "/usr/share/locale")
endif()

# https://cmake.org/cmake/help/latest/command/add_subdirectory.html
add_subdirectory(uulib)
add_subdirectory(pan)
add_subdirectory(po)
add_subdirectory(help)

# https://cmake.org/cmake/help/latest/command/configure_file.html
configure_file(${CMAKE_SOURCE_DIR}/config-cmake.h.in ${CMAKE_BINARY_DIR}/config.h)

target_compile_definitions(pan PRIVATE "PANLOCALEDIR=\"${LOCALEDIR}\"")

# https://cmake.org/cmake/help/latest/command/target_link_libraries.html
target_link_libraries(pan
  pan-cc-gui
  pan-c-gui
  data-impl
  tasks
  data
  usenet-utils
  generalutils
  uulib
  ${CMAKE_THREAD_LIBS_INIT}
  PkgConfig::GTK3
  PkgConfig::GMIME
)

if(WIN32)
  target_link_libraries(pan ws2_32)
endif()

# Installation
# https://cmake.org/cmake/help/book/mastering-cmake/chapter/Install.html
# https://cmake.org/cmake/help/latest/command/install.html
install(TARGETS pan DESTINATION ${CMAKE_INSTALL_BINDIR})

set(meta "org.gnome.pan.metainfo.xml")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${meta}.in" "${CMAKE_CURRENT_BINARY_DIR}/${meta}")
install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/${meta}"
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
)

set(desktop "org.gnome.pan.desktop")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${desktop}.in" "${CMAKE_CURRENT_BINARY_DIR}/${desktop}")
install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/${desktop}"
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications"
)

set(dbus-file "org.gnome.pan.service")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${dbus-file}.in" "${CMAKE_CURRENT_BINARY_DIR}/${dbus-file}")
install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/${dbus-file}"
  DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/dbus-1/services"
)

# install pan man page
file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/man1")
file(COPY_FILE "${CMAKE_CURRENT_SOURCE_DIR}/pan.1" "${CMAKE_CURRENT_BINARY_DIR}/man1/pan.1")
install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/man1" TYPE MAN)

=== help/CMakeLists.txt ===
# need to build docbook
# see https://build.opensuse.org/package/live_build_log/openSUSE:Factory/pan/standard/x86_64

if (ENABLE_MANUAL)

  # https://cmake.org/cmake/help/latest/command/find_program.html
  find_program(has_itstool NAMES itstool REQUIRED)
  file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/C/figures")
  set(png_path "figures/pan_window.png")
  file(COPY_FILE "${CMAKE_CURRENT_SOURCE_DIR}/C/${png_path}" "${CMAKE_CURRENT_BINARY_DIR}/C/${png_path}")
  file(COPY_FILE "${CMAKE_CURRENT_SOURCE_DIR}/C/index.docbook" "${CMAKE_CURRENT_BINARY_DIR}/C/index.docbook")

  set(lang_list cs de es sv)
  foreach(lang IN LISTS lang_list)
    file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${lang}/figures")
    add_custom_target(
      "${lang}-docbook" ALL
      BYPRODUCTS "${lang}/${lang}.mo"
      DEPENDS "${lang}/${lang}.po"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${lang}"
      COMMAND msgfmt -o "${lang}.mo" "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/${lang}.po"
      COMMAND itstool -m "${lang}.mo" "${CMAKE_CURRENT_SOURCE_DIR}/C/index.docbook"
    )
    file(CREATE_LINK "../../../C/pan/${png_path}" "${CMAKE_CURRENT_BINARY_DIR}/${lang}/${png_path}" SYMBOLIC)
  endforeach()

  foreach(lang IN LISTS lang_list ITEMS C)
    # https://cmake.org/cmake/help/latest/command/install.html#files
    install(
      FILES "${CMAKE_CURRENT_BINARY_DIR}/${lang}/index.docbook"
      DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/help/${lang}/pan/"
    )
    install(
      FILES    "${CMAKE_CURRENT_BINARY_DIR}/${lang}/${png_path}"
      DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/help/${lang}/pan/figures"
    )
  endforeach()

  install(FILES "C/legal.xml" DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/help/C/pan/")

endif()

=== pan/CMakeLists.txt ===
# order of add_subdirectory is important
foreach(subdir data data-impl general icons tasks usenet-utils gui)
  add_subdirectory(${subdir})
endforeach()

=== po/CMakeLists.txt ===
# see https://cmake.org/cmake/help/latest/module/FindGettext.html
find_package(Gettext)
file(STRINGS "${CMAKE_SOURCE_DIR}/po/LINGUAS" lang_list REGEX "^[a-z]")
foreach(lang IN LISTS lang_list)
  # this creates the gmo file in build directory instead of po/*.gmo. Although this is
  # a change from previous build system, it may not be a problem
  GETTEXT_PROCESS_PO_FILES(
    ${lang} ALL
    PO_FILES "${CMAKE_SOURCE_DIR}/po/${lang}.po"
  )
  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${lang}.gmo
    DESTINATION "${CMAKE_INSTALL_LOCALEDIR}/${lang}/LC_MESSAGES/"
    RENAME pan.mo
  )
endforeach()
add_dependencies(pan pofiles)

=== uulib/CMakeLists.txt ===
# collect up the source files
file(GLOB SRC_FILES "*.c")

add_library(uulib STATIC ${SRC_FILES})

target_include_directories(uulib PRIVATE ".")
target_compile_definitions(uulib PUBLIC "PROTOTYPES")

target_link_libraries(uulib PUBLIC PkgConfig::GLIB)

# see https://cmake.org/cmake/help/latest/module/FindZLIB.html
if(ZLIB_FOUND)
    target_include_directories(uulib PUBLIC ${ZLIB_INCLUDE_DIRS})
    target_link_libraries(uulib PUBLIC ${ZLIB_LIBRARIES})
endif()

=== pan/data-impl/CMakeLists.txt ===
add_library(data-impl
 article-filter.cc
 article-rules.cc
 data-io.cc
 data-impl.cc
 groups.cc
 headers.cc
 profiles.cc
 server.cc
 my-tree.cc
 task-archive.cc
 xover.cc
)

# Sanity checking
# https://cmake.org/cmake/help/latest/command/add_compile_options.html
target_compile_options(data-impl PRIVATE "${CXX_STD}" "-Wreorder" "-Wzero-as-null-pointer-constant")

target_link_libraries(data-impl PUBLIC PkgConfig::GTK3)
target_link_libraries(data-impl PUBLIC PkgConfig::GMIME)

if(WANT_GNUTLS)
  target_link_libraries(data-impl PUBLIC PkgConfig::GNUTLS)
endif()

if(WANT_GKR)
  target_link_libraries(data-impl PUBLIC PkgConfig::LIBSECRET)
  target_link_libraries(data-impl PUBLIC PkgConfig::GCR3)
endif()

=== pan/general/CMakeLists.txt ===
add_library(generalutils
 article_number.cc
 debug.cc
 e-util.cc
 file-util.cc
 log.cc
 line-reader.cc
 progress.cc
 quark.cc
 string-view.cc
 text-match.cc
 utf8-utils.cc
 worker-pool.cc
 compression.cc
)

# Sanity checking
# https://cmake.org/cmake/help/latest/command/add_compile_options.html
target_compile_options(generalutils PRIVATE "${CXX_STD}" "-Wreorder" "-Wzero-as-null-pointer-constant")

# see https://cmake.org/cmake/help/latest/module/FindZLIB.html
if(ZLIB_FOUND)
  my_target_system_lib(generalutils PUBLIC ZLIB)
endif()

target_link_libraries(generalutils PUBLIC PkgConfig::GMIME)
target_link_libraries(generalutils PUBLIC PkgConfig::GTK3)

=== pan/gui/CMakeLists.txt ===
set(SRC_CC_FILES
 actions.cc
 body-pane.cc
 dl-headers-ui.cc
 editor-spawner.cc
 group-pane.cc
 group-prefs-dialog.cc
 group-prefs.cc
 header-pane.cc
 hig.cc
 load-icon.cc
 log-ui.cc
 pan-file-entry.cc
 pan-tree.cc
 post-ui.cc
 prefs-file.cc
 prefs-ui.cc
 prefs.cc
 profiles-dialog.cc
 progress-view.cc
 render-bytes.cc
 save-attach-ui.cc
 save-ui.cc
 score-add-ui.cc
 score-view-ui.cc
 server-ui.cc
 task-pane.cc
 url.cc
)

set(SRC_C_FILES
 e-action-combo-box.c
 e-charset-combo-box.c
 e-charset-dialog.c
 e-charset.c
 e-cte-dialog.c
 xface.c
)

# https://cmake.org/cmake/help/latest/command/add_library.html
add_library(pan-cc-gui STATIC ${SRC_CC_FILES})

add_library(pan-c-gui STATIC ${SRC_C_FILES})

foreach (my_target "pan-cc-gui" "pan-c-gui")
  target_link_libraries(${my_target} PRIVATE tasks)

  target_link_libraries(${my_target} PUBLIC PkgConfig::GTK3)
  target_link_libraries(${my_target} PUBLIC PkgConfig::GMIME)

  if(WANT_GSPELL)
    my_target_system_lib(${my_target} PUBLIC GSPELL)
  endif()

  if(WANT_WEBKIT)
    target_link_libraries(${my_target} PUBLIC PkgConfig::WEBKITGTK)
  endif()

  if(WANT_GNUTLS)
    target_link_libraries(${my_target} PUBLIC PkgConfig::GNUTLS)
  endif()

  if(WANT_NOTIFY)
    target_link_libraries(${my_target} PUBLIC PkgConfig::LIBNOTIFY)
  endif()

  if(Iconv_FOUND)
    my_target_system_lib(${my_target} PUBLIC Iconv)
  endif()

  if(WANT_GKR)
    target_link_libraries(${my_target} PUBLIC PkgConfig::LIBSECRET)
    target_link_libraries(${my_target} PUBLIC PkgConfig::GCR3)
  endif()

  if(WANT_WEBKIT)
    target_link_libraries(${my_target} PUBLIC PkgConfig::WEBKITGTK)
  endif()

endforeach()

# Sanity checking
# https://cmake.org/cmake/help/latest/command/add_compile_options.html
target_compile_options(pan-cc-gui PRIVATE "-Wreorder" "${CXX_STD}"  "-Wzero-as-null-pointer-constant")

if(WIN32)
  target_sources(pan PRIVATE panrc.rc)
endif()

=== pan/icons/CMakeLists.txt ===

file(GLOB public_icons hicolor_apps_*.pan.png)

# keep .png otherwise dependency check fails
list(APPEND stock_images
	icon_article_read.png
	icon_article_unread.png
	icon_binary_complete.png
	icon_binary_complete_read.png
	icon_binary_incomplete.png
	icon_binary_incomplete_read.png
	icon_bluecheck.png
	icon_red_flag.png
	icon_by_me.png
	icon_by_others.png
	icon_compose_followup.png
	icon_compose_post.png
	icon_disk.png
	icon_empty.png
	icon_filter.png
	icon_filter_only_attachments.png
	icon_filter_only_cached.png
	icon_filter_only_me.png
	icon_filter_only_read.png
	icon_filter_only_unread.png
	icon_filter_only_watched.png
	icon_get_dialog.png
	icon_get_flagged.png
	icon_get_selected.png
	icon_get_subscribed.png
	icon_layout_1.png
	icon_layout_2.png
	icon_layout_3.png
	icon_layout_4.png
	icon_layout_5.png
	icon_pan_about_logo.png
	icon_pan.png
	icon_read_group.png
	icon_read_more.png
	icon_read_less.png
	icon_read_unread_article.png
	icon_read_unread_thread.png
	icon_score.png
	icon_search_pulldown.png
	icon_x.png
	icon_mozilla_frown.png
	icon_mozilla_smile.png
	icon_mozilla_surprised.png
	icon_mozilla_tongueout.png
	icon_mozilla_wink.png
	icon_plain.png
	icon_cert.png
	icon_status_online.png
  icon_status_offline.png
  icon_status_active.png
  icon_status_queue_empty.png
  icon_status_error.png
  icon_status_idle.png
  icon_status_new_articles.png
  icon_sig_ok.png
  icon_sig_fail.png
  icon_show_signature.png
  icon_prefs_applications.png
  icon_prefs_extras.png
  icon_prefs_hotkeys.png
  icon_prefs_behavior.png
  icon_prefs_fonts.png
  icon_prefs_upload.png
  icon_prefs_colors.png
  icon_prefs_headers.png
  icon_prefs_layout.png
  icon_prefs_actions.png
  icon_prefs_panes.png
  icon_expand_thread.png
  icon_collapse_thread.png
)

foreach(image_file IN LISTS stock_images)
  string(REPLACE "\.png" "" image "${image_file}")
  # install png files
  install(FILES ${image_file} DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/pan/icons/")
endforeach()

# install hicolor icons
foreach (icon_path ${public_icons})
  cmake_path(GET icon_path FILENAME icon_file)
  string(REPLACE "_" ";" words ${icon_file})
  list(GET words 0 theme)
  list(GET words 1 context)
  list(GET words 2 size)
  list(GET words 3 target)
  set(destdir "${CMAKE_INSTALL_DATAROOTDIR}/icons/${theme}/${size}/${context}/")
  install(FILES ${icon_file} DESTINATION ${destdir} RENAME ${target})
endforeach()

=== pan/tasks/CMakeLists.txt ===
add_library(tasks
  decoder.cc
  encoder.cc
  task.cc
  task-article.cc
  task-groups.cc
  task-post.cc
  task-xover.cc
  task-upload.cc
  nntp.cc
  nzb.cc
  queue.cc
  upload-queue.cc
  socket.cc
  socket-impl-main.cc
  socket-impl-openssl.cc
  socket-impl-gio.cc
  socket-impl-scripted.cc
  nntp-pool.cc
)

# Sanity checking
# https://cmake.org/cmake/help/latest/command/add_compile_options.html
target_compile_options(tasks PRIVATE "${CXX_STD}" "-Wreorder" "-Wzero-as-null-pointer-constant")

target_link_libraries(tasks PUBLIC PkgConfig::GTK3)

target_link_libraries(tasks PUBLIC PkgConfig::GMIME)

if(Iconv_FOUND)
  my_target_system_lib(tasks PUBLIC Iconv)
endif()

if(WANT_GNUTLS)
  target_link_libraries(tasks PUBLIC PkgConfig::GNUTLS)
endif()

=== pan/usenet-utils/CMakeLists.txt ===
add_library(usenet-utils
 filter-info.cc
 rules-info.cc
 gnksa.cc
 message-check.cc
 mime-utils.cc
 numbers.cc
 scorefile.cc
 ssl-utils.cc
 text-massager.cc
 url-find.cc
 blowfish.cc
 gpg.cc
)


# TODO: fix  message-check-test and add it to this list
set(test-programs gnksa-test numbers-test scorefile-test text-massager-test url-find-test)

target_link_libraries(usenet-utils PUBLIC PkgConfig::GTK3)
target_link_libraries(usenet-utils PUBLIC PkgConfig::GMIME)
target_link_libraries(usenet-utils PUBLIC PkgConfig::GLIB)

if(WANT_GNUTLS)
  target_link_libraries(usenet-utils PUBLIC PkgConfig::GNUTLS)
endif()

foreach(test ${test-programs})
  add_executable(${test} ${test}.cc)
  # Sanity checking
  # https://cmake.org/cmake/help/latest/command/add_compile_options.html
  target_compile_options(${test} PRIVATE "${CXX_STD}" "-Wreorder" "-Wzero-as-null-pointer-constant")
  target_link_libraries(${test} usenet-utils generalutils pan-cc-gui)
  add_test(NAME ${test}-test COMMAND ${test})
endforeach()

=== debian/changelog ===
pan (0.164-1) unstable; urgency=medium

  * new upstream version
  - fix article part detection where multipart articles
    were detected as many articles instaed of one article
    with many parts.
  - fix crash when displaying emoticon replacement

 -- Dominique Dumont <dod@debian.org>  Sun, 24 Aug 2025 19:46:46 +0200

=== debian/control ===
Source: pan
Maintainer: Dominique Dumont <dod@debian.org>
Section: news
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               itstool,
               libdbus-1-dev,
               libgcr-3-dev,
               libgmime-3.0-dev,
               libgnutls28-dev,
               libgtk-3-dev,
               libgspell-1-dev,
               libnotify-dev,
               libsecret-1-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/pan
Vcs-Git: https://salsa.debian.org/debian/pan.git
Homepage: https://pan.rebelbase.com/
Rules-Requires-Root: no

Package: pan
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gnome-keyring,
         gnupg
Description: newsreader based on GTK3, which looks like Forte Agent
 Pan is a newsreader, loosely based on Agent and Gravity, which attempts to be
 pleasant to use for new and advanced users alike. It has all the typical
 features found in newsreaders and also supports offline newsreading,
 sophisticated filtering, multiple connections, and a number of extra features
 for power users and alt.binaries fans.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# see FEATURE AREAS in dpkg-buildflags(1)
DEB_BUILD_MAINT_OPTIONS=hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake --without=autoreconf

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_MANUAL=1 -DWANT_DBUS=1 -DWANT_GKR=1 -DWANT_NOTIFY=1 -DWANT_GMIME=0

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://gitlab.gnome.org/GNOME/pan/-/tags \
             /GNOME/pan/-/archive/v[\d.]+/pan-v(\d[\d.]*)\.tar\.gz

## pan 0.165

=== debian/changelog ===
pan (0.165-1~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 28 Jan 2026 09:59:04 -0800

pan (0.165-1) unstable; urgency=medium

  * new upstream version
    - task-xover: fix date parsing, a potential crash and a memory leak
    - group-prefs-dialog: fix missing spellcheck language entry
    - header-pane: fix crash when backspace key is hit wihout articles
  * fix debian/watch

 -- Dominique Dumont <dod@debian.org>  Sat, 24 Jan 2026 12:21:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: pan
-Maintainer: Dominique Dumont <dod@debian.org>
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Dominique Dumont <dod@debian.org>
 Section: news
 Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
+               cmake,
                itstool,
                libdbus-1-dev,
                libgcr-3-dev,
                libgmime-3.0-dev,
                libgnutls28-dev,
+               libgspell-1-dev,
                libgtk-3-dev,
-               libgspell-1-dev,
                libnotify-dev,
                libsecret-1-dev
 Standards-Version: 4.7.0
@@ -21,10 +22,7 @@
 
 Package: pan
 Architecture: any
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         gnome-keyring,
-         gnupg
+Depends: gnome-keyring, gnupg, ${misc:Depends}, ${shlibs:Depends}
 Description: newsreader based on GTK3, which looks like Forte Agent
  Pan is a newsreader, loosely based on Agent and Gravity, which attempts to be
  pleasant to use for new and advanced users alike. It has all the typical

=== debian/rules ===
--- 
+++ 
@@ -19,4 +19,13 @@
 	dh $@ --buildsystem=cmake --without=autoreconf
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DENABLE_MANUAL=1 -DWANT_DBUS=1 -DWANT_GKR=1 -DWANT_NOTIFY=1 -DWANT_GMIME=0
+	dh_auto_configure -- -DENABLE_MANUAL=1 \
+	                     -DWANT_DBUS=1 \
+	                     -DWANT_GKR=1 \
+	                     -DWANT_NOTIFY=1 \
+	                     -DWANT_GMIME=0
+
+# No dbgsym packages:
+override_dh_strip:
+	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
+	dh_strip --no-automatic-dbgsym

## pan 1.3

=== DESCRIPTION ===
Package: pan
Version: 1.3
Date: 2015-02-10
Title: Multiple Imputation for Multivariate Panel or Clustered Data
Author: Original by Joseph L. Schafer 
Maintainer: Jing hua Zhao <jinghua.zhao@mrc-epid.cam.ac.uk>
Suggests: mitools, lme4
LazyData: Yes
LazyLoad: Yes
Description: Multiple imputation for multivariate panel or clustered data.
License: Unlimited
URL: http://www.stat.psu.edu/~jls/misoftwa.html
Packaged: 2015-02-10 22:15:01 UTC; jhz22
NeedsCompilation: yes
License_restricts_use: no
Repository: CRAN
Date/Publication: 2015-02-10 23:56:30

## pan 1.4

=== DESCRIPTION ===
Package: pan
Version: 1.4
Date: 2016-02-10
Title: Multiple Imputation for Multivariate Panel or Clustered Data
Author: Original by Joseph L. Schafer 
Maintainer: Jing hua Zhao <jinghua.zhao@mrc-epid.cam.ac.uk>
Suggests: mitools, lme4
LazyData: Yes
LazyLoad: Yes
Description: Multiple imputation for multivariate panel or clustered data.
License: GPL-3
NeedsCompilation: yes
Packaged: 2016-02-10 11:47:23 UTC; jhz22
License_restricts_use: no
Repository: CRAN
Date/Publication: 2016-02-10 18:57:27

## pan 1.6

=== DESCRIPTION ===
Package: pan
Version: 1.6
Date: 2018-06-29
Title: Multiple Imputation for Multivariate Panel or Clustered Data
Author: Original by Joseph L. Schafer 
Maintainer: Jing hua Zhao <jinghuazhao@hotmail.com>
Suggests: mitools, lme4
LazyData: Yes
LazyLoad: Yes
Description: It provides functions and examples for maximum likelihood estimation for
              generalized linear mixed models and Gibbs sampler for multivariate linear
              mixed models with incomplete data, as described in Schafer JL (1997)
              "Imputation of missing covariates under a multivariate linear mixed model".
              Technical report 97-04, Dept. of Statistics, The Pennsylvania State University.
License: GPL-3
NeedsCompilation: yes
Packaged: 2018-06-29 10:01:17 UTC; jhz22
License_restricts_use: no
Repository: CRAN
Date/Publication: 2018-06-29 14:12:56 UTC

## pan 1.8

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: pan
-Version: 1.6
-Date: 2018-06-29
+Version: 1.8
+Date: 2023-6-25
 Title: Multiple Imputation for Multivariate Panel or Clustered Data
 Author: Original by Joseph L. Schafer 
 Maintainer: Jing hua Zhao <jinghuazhao@hotmail.com>
@@ -14,7 +14,7 @@
               Technical report 97-04, Dept. of Statistics, The Pennsylvania State University.
 License: GPL-3
 NeedsCompilation: yes
-Packaged: 2018-06-29 10:01:17 UTC; jhz22
+Packaged: 2023-06-25 09:00:51 UTC; jhz22
 License_restricts_use: no
 Repository: CRAN
-Date/Publication: 2018-06-29 14:12:56 UTC
+Date/Publication: 2023-06-25 12:40:02 UTC

## pan 1.9

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: pan
-Version: 1.8
-Date: 2023-6-25
+Version: 1.9
+Date: 2023-8-19
 Title: Multiple Imputation for Multivariate Panel or Clustered Data
 Author: Original by Joseph L. Schafer 
 Maintainer: Jing hua Zhao <jinghuazhao@hotmail.com>
@@ -14,7 +14,7 @@
               Technical report 97-04, Dept. of Statistics, The Pennsylvania State University.
 License: GPL-3
 NeedsCompilation: yes
-Packaged: 2023-06-25 09:00:51 UTC; jhz22
-License_restricts_use: no
+Packaged: 2023-12-07 16:29:39 UTC; hornik
 Repository: CRAN
-Date/Publication: 2023-06-25 12:40:02 UTC
+Date/Publication: 2023-12-07 17:57:27
+Depends: R (>= 2.10)
